Imports System.Runtime.InteropServices

''' <summary>
''' Class used for playing the 'Click' sound in the ExplorerControls library
''' </summary>
''' <remarks></remarks>
<ClassInterface(ClassInterfaceType.None)> _
Public Class Sounds
    'API call for playing sounds in memory
    Private Declare Function PlaySound Lib "winmm.dll" (ByVal data() As Byte, _
        ByVal hMod As IntPtr, ByVal hwFlags As Integer) As Integer
    Private Const SND_ASYNC As Integer = &H1        'Play asynchronously
    Private Const SND_MEMORY As Integer = &H4       'Play wav in memory

    Private Shared m_silent As Boolean = False
    ''' <summary>
    ''' Set to False to suppress all 'Click' sounds from the ExplorerControls library
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Property Silent() As Boolean
        Get
            Return m_silent
        End Get
        Set(ByVal Value As Boolean)
            m_silent = Value
        End Set
    End Property

    'Play embedded .wav resource
    ''' <summary>
    ''' Play a 'Click' sound
    ''' </summary>
    ''' <remarks></remarks>
    Public Shared Sub Click()

        If m_silent Then Exit Sub

        'Get the button click sound from the resource stream.
        Dim WavStrm As IO.Stream = _
            Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream(GetType(Sounds), _
            "clickerx.wav")

        'ReDim the byte array to be the size of the embedded .wav
        Dim click(CInt(WavStrm.Length)) As Byte
        'Load the .wav from the stream into the byte array
        WavStrm.Read(click, 0, Int(CType(WavStrm.Length, Integer)))

        PlaySound(click, IntPtr.Zero, SND_ASYNC Or SND_MEMORY)
    End Sub


End Class
